#include <sdktools>
#include <shop>

#pragma newdecls required

public Plugin myinfo = 
{
	name = "[Shop] Sticky Bomb", //Silly Bomb. Silly - глупый
	author = "HolyHender | Credits: Boeing767 aka asdf",
	description = "",
	version = "1.0.0",
};

ConVar cvar_Enable, cvar_Distance, cvar_Price, cvar_SellPrice, cvar_Duration;

bool g_bUseStickyBomb[MAXPLAYERS + 1];

ItemId id;

public void OnPluginStart()
{
	HookEvent("bomb_planted", Event_BombPlanted);

	cvar_Enable = CreateConVar("sm_shop_sticky_bomb_enable", "1", "Включён ли плагин", _, true, 0.0, true, 1.0);
	
    cvar_Distance = CreateConVar("sm_shop_sticky_bomb_distance", "65.0", "Дистанция, на которую можно ставить бомбу.");

    (cvar_Price = CreateConVar("sm_shop_sticky_bomb_price", "1000", "Стоимость покупки липкой бомбы.")).AddChangeHook(OnConVarChange);
	(cvar_SellPrice = CreateConVar("sm_shop_sticky_bomb_sellprice", "800", "Стоимость продажи липкой бомбы.")).AddChangeHook(OnConVarChange);
    (cvar_Duration = CreateConVar("sm_shop_sticky_bomb_duration", "86400", "Длительность липкой бомбы в секундах.")).AddChangeHook(OnConVarChange);

	AutoExecConfig(true, "sticky_bomb", "shop");

    if (Shop_IsStarted()) Shop_Started();
}

public void Shop_Started()
{
	CategoryId category_id = Shop_RegisterCategory("stuff", "Разное", "");

	if (Shop_StartItem(category_id, "sticky_bomb"))
	{
		Shop_SetInfo("Липкая бомба", "", cvar_Price.IntValue, cvar_SellPrice.IntValue, Item_Togglable, cvar_Duration.IntValue);
		Shop_SetCallbacks(OnItemRegistered, OnStickyBombUse);
		Shop_EndItem();
	}
}

public void OnItemRegistered(CategoryId category_id, const char[] category, const char[] item, ItemId item_id)
{
	id = item_id;
}

public ShopAction OnStickyBombUse(int iClient, CategoryId category_id, const char[] sCategory, ItemId item_id, const char[] sItem, bool isOn, bool elapsed)
{
	if (isOn || elapsed)
	{
		g_bUseStickyBomb[iClient] = false;
		return Shop_UseOff;
	}

	g_bUseStickyBomb[iClient] = true;

	return Shop_UseOn;
}

public void OnClientDisconnect(int iClient)
{
	g_bUseStickyBomb[iClient] = false;
}

public void OnPluginEnd() 
{
	Shop_UnregisterMe();
}

public void OnConVarChange(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	if(id == INVALID_ITEM)
	{
		return;
	}

	if(cvar == cvar_Price) Shop_SetItemPrice(id, cvar.IntValue);
	else if(cvar == cvar_SellPrice) Shop_SetItemSellPrice(id, cvar.IntValue);
	else if(cvar == cvar_Duration) Shop_SetItemValue(id, cvar.IntValue);
}


public void Event_BombPlanted(Event event, char[] name, bool dontBroadcast)
{
	if(!cvar_Enable.BoolValue)
		return;

	int client = GetClientOfUserId(event.GetInt("userid"));
    int ent = FindEntityByClassname(MaxClients+1, "planted_c4");
    float pos[3], ang[3], origin[3];
    
    if(IsClientInGame(client) && IsPlayerAlive(client) && g_bUseStickyBomb[client])
	{
        GetClientEyePosition(client, pos); 
        GetClientEyeAngles(client, ang); 
        GetClientEyePosition(client, origin);

        TR_TraceRayFilter(pos, ang, MASK_SOLID, RayType_Infinite, TR_Filter, client);
        TR_GetEndPosition(pos);

        if(GetVectorDistance(origin, pos) < cvar_Distance.FloatValue)
        {
            TR_GetPlaneNormal(null, ang);
            GetVectorAngles(ang, ang);

            ang[0] -= 90.0; 
            ang[2] -= 180.0;

            TeleportEntity(ent, pos, ang, NULL_VECTOR);
        }
    }
}

public bool TR_Filter(int iEnt, int iMask, any iEntity)
{
	if(iEnt != iEntity)
		return true;

	return false;
}